// -----JS CODE-----
// @input SceneObject marker
// @input SceneObject water
// @input vec4 waterColor = {0,0,0,1} {"widget":"color"}
// @input SceneObject coffee
// @input vec4 coffeeColor = {0,0,0,1} {"widget":"color"}
// @input SceneObject soda
// @input vec4 sodaColor = {0,0,0,1} {"widget":"color"}
// @input SceneObject milk
// @input vec4 milkColor = {0,0,0,1} {"widget":"color"}
// @input SceneObject ground
// @input Component.Label label

var markerTransform = script.marker.getTransform();;
var initialized = false;
var previousDrink = null;

var drinkConfigs = [
    {
        name: "Milk",
        tweenObj: script.milk,
        color: script.milkColor,
        description: "Strength",
    },
    {
        name: "Water",
        tweenObj: script.water,
        color: script.waterColor,
        description: "Stamina",
    },
    {
        name: "Soda",
        tweenObj: script.soda,
        color: script.sodaColor,
        description: "Speed",
    },
    {
        name: "Coffee",
        tweenObj: script.coffee,
        color: script.coffeeColor,
        description: "Energy",
    }
];

var anglePerItem = (360 / drinkConfigs.length);

function onUpdateEvent(eventData)
{
    calculateMarkerOrientation();
}
var updateEvent = script.createEvent("UpdateEvent");
updateEvent.bind(onUpdateEvent); 


function calculateMarkerOrientation()
{
    var currentOrientation = markerTransform.getWorldRotation().toEulerAngles().z * 180/Math.PI;

    if (currentOrientation < 0) {
        currentOrientation += 360;
    }
    if (currentOrientation > 360) {
        currentOrientation -= 360;
    }

    var ind = Math.floor(currentOrientation / anglePerItem);
    var currentDrink = drinkConfigs[ind].name;
    if (currentDrink != previousDrink) 
    {
        viewDrinks(currentDrink);
        previousDrink = currentDrink;
    }

}

function showOrHideTween(tweenObj, show) 
{
    global.tweenManager.startTween(tweenObj, show ? "show" : "hide");
}

function viewDrinks(drinkName) {

    for (var i=0; i<drinkConfigs.length; i++) {
        var config = drinkConfigs[i];
        var active = drinkName == config.name;
        showOrHideTween(config.tweenObj, active);
        if (active) 
        {
            global.tweenManager.setEndValue(script.ground, "changecolor", config.color);
            global.tweenManager.startTween(script.ground, "changecolor");
            script.label.text = config.description.toUpperCase();
        }
    }
}

